package com.ruoyi.programManagement.quartz;

import com.ruoyi.common.core.domain.AjaxResult;
import com.ruoyi.programManagement.entity.BEnterpriseNew;
import com.ruoyi.programManagement.entity.SzEnforExamine;
import com.ruoyi.programManagement.entity.response.BPlanEnterpriseResponse;
import com.ruoyi.programManagement.mapper.BEnterpriseNewMapper;
import com.ruoyi.programManagement.service.BPlanEnterpriseService;
import com.ruoyi.programManagement.service.IBEnterpriseNewService;
import com.ruoyi.programManagement.service.ISzEnforExamineService;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.apache.ibatis.session.SqlSession;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.transaction.annotation.Transactional;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import javax.annotation.Resource;
import java.util.List;

/**
 * 定时任务更新企业新表
 */
//@Configuration
//@EnableScheduling
@Api(tags = "定时任务")
@RestController
@Transactional(rollbackFor = Exception.class)
@RequestMapping("/pharmaceuticals/quartz")
public class EnterpristQuartz {


    @Autowired
    private BEnterpriseNewMapper bEnterpriseNewMapper;


    @Autowired
    private ISzEnforExamineService szEnforExamineService;

    @Resource
    private IBEnterpriseNewService bEnterpriseNewService;

    @Resource
    private BPlanEnterpriseService bPlanEnterpriseService;

    // 每周一早上五点5点执行一次任务 生成企业新表
//    @Scheduled(cron = "0 0 17 ? * SUN")
    @GetMapping("/getList")
    @ApiOperation(value = "定时任务")
    public AjaxResult updateInformationData() {
        //三表关联查询数据
        List<BEnterpriseNew> list = bEnterpriseNewMapper.seletAll();
        //清空企业新表中的数据
        bEnterpriseNewMapper.deletAll();
        bEnterpriseNewService.saveBatch(list);
        return AjaxResult.success();
    }


    // 定时任务修改更新计划表的检查状态、检查id、检查时效字段
    @GetMapping("/updateExamine")
    @ApiOperation(value = "定时任务修改更新计划表的检查状态、检查id、检查时效字段")
    public AjaxResult updateExamine() {
        //查询计划表中的所有数据
        List<BPlanEnterpriseResponse> list = bPlanEnterpriseService.selectBPlanEnterpriseList(null);
        for (BPlanEnterpriseResponse a : list) {
            BEnterpriseNew bEnterpriseNew = new BEnterpriseNew();
            List<SzEnforExamine> szEnforExamineList = szEnforExamineService.getByEnterPriseCode(a.getEnterpriseId());
            for (SzEnforExamine b : szEnforExamineList) {
                bEnterpriseNew.setId(a.getId());
                bEnterpriseNew.setExamineEndTime(b.getExamineEndTime());
                bEnterpriseNewMapper.updateBEnterpriseNew(bEnterpriseNew);
            }
        }
        return null;
    }



}
